/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumDatatype;
import de.ship.db.tables.records.VInputTypeRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VInputType extends TableImpl<VInputTypeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_input_type</code>
     */
    public static final VInputType V_INPUT_TYPE = new VInputType();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VInputTypeRecord> getRecordType() {
        return VInputTypeRecord.class;
    }

    /**
     * The column <code>common_dd.v_input_type.lastchange</code>.
     */
    public final TableField<VInputTypeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_input_type.pk</code>.
     */
    public final TableField<VInputTypeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_type.has_valuelist</code>.
     */
    public final TableField<VInputTypeRecord, Boolean> HAS_VALUELIST = createField(DSL.name("has_valuelist"), SQLDataType.BOOLEAN, this, "");

    /**
     * The column <code>common_dd.v_input_type.data_type</code>.
     */
    public final TableField<VInputTypeRecord, EnumDatatype> DATA_TYPE = createField(DSL.name("data_type"), SQLDataType.VARCHAR.asEnumDataType(EnumDatatype.class), this, "");

    /**
     * The column <code>common_dd.v_input_type.inputtype_descr</code>.
     */
    public final TableField<VInputTypeRecord, String> INPUTTYPE_DESCR = createField(DSL.name("inputtype_descr"), SQLDataType.CLOB, this, "");

    private VInputType(Name alias, Table<VInputTypeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VInputType(Name alias, Table<VInputTypeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_input_type" as  SELECT lastchange,
          inputtype AS pk,
              CASE has_valuelist
                  WHEN 0 THEN false
                  WHEN 1 THEN true
                  ELSE NULL::boolean
              END AS has_valuelist,
          data_type,
          inputtype_descr
         FROM common_dd.t_input_type
        ORDER BY inputtype;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_input_type</code> table reference
     */
    public VInputType(String alias) {
        this(DSL.name(alias), V_INPUT_TYPE);
    }

    /**
     * Create an aliased <code>common_dd.v_input_type</code> table reference
     */
    public VInputType(Name alias) {
        this(alias, V_INPUT_TYPE);
    }

    /**
     * Create a <code>common_dd.v_input_type</code> table reference
     */
    public VInputType() {
        this(DSL.name("v_input_type"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VInputType as(String alias) {
        return new VInputType(DSL.name(alias), this);
    }

    @Override
    public VInputType as(Name alias) {
        return new VInputType(alias, this);
    }

    @Override
    public VInputType as(Table<?> alias) {
        return new VInputType(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputType rename(String name) {
        return new VInputType(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputType rename(Name name) {
        return new VInputType(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputType rename(Table<?> name) {
        return new VInputType(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputType where(Condition condition) {
        return new VInputType(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputType where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputType where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputType where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputType where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputType where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputType where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputType where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputType whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputType whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
